// BonDriver.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "BonTuner.h"

void OpenLog( HMODULE hModule ) ;
void CloseLog( void ) ;
void LogPrintf( const char* pszFormat,... ) ;

/////////////////////////////////////////////////////////////////////////////
// DLLMain֐

BOOL APIENTRY DllMain(HINSTANCE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
    switch(ul_reason_for_call){
	case DLL_PROCESS_ATTACH:
		// Ot@CJ
		OpenLog( hModule ) ;
		// [NoL
		#ifdef _DEBUG
		::_CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF | _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG)); 
		#endif
		// W[nhۑ
		CBonTuner::m_hModule = hModule;
		break;

	case DLL_PROCESS_DETACH:
		// J̏ꍇ̓CX^XJ		
		if(CBonTuner::m_pThis)CBonTuner::m_pThis->Release();
		// Ot@C
		CloseLog() ;
		break;
	}
    return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Oo

#include <stdio.h>
#include <share.h>
#include <userenv.h>

#pragma comment(lib, "userenv.lib")

HANDLE hSem = NULL ;
char szMyPath[_MAX_PATH] ;
FILE* pLog = NULL ;

DWORD WINAPI ThreadForFlush( LPVOID lpParameter ) ;

void OpenLog( HINSTANCE hModule )
{
	// ݖh~pZ}tH쐬
	if ( !( hSem = CreateSemaphore( NULL, 1, 1, NULL ) ) ) return ;
	// ̖O胍Ot@C߂
	char szDir[_MAX_PATH] ;
	DWORD dLen = _MAX_PATH ;
	if ( !GetAllUsersProfileDirectoryA( szDir, &dLen ) ) strcpy_s( szDir, _MAX_PATH, "." ) ;
	if ( !GetModuleFileNameA( hModule, szMyPath, _MAX_PATH ) ) return ;
	char szName[_MAX_FNAME] ;
	_splitpath_s( szMyPath, NULL, 0, NULL, 0, szName, _MAX_FNAME, NULL, 0 ) ;
	char szLog[_MAX_PATH] ;
	sprintf_s( szLog, _MAX_PATH, "%s\\%s.log", szDir, szName ) ;
	// [Xrhł̓Ot@C݂Ȃꍇ͍쐬Ȃ
	#ifndef _DEBUG
	if ( pLog = _fsopen( szLog, "rt", _SH_DENYWR ) ) fclose( pLog ) ;
	else return ;
	#endif
	// Ot@CJ
	if ( !( pLog = _fsopen( szLog, "at", _SH_DENYWR ) ) ) return ;
	// JnL^
	char szExePath[_MAX_PATH] = "??" ;
	GetModuleFileNameA( NULL, szExePath, _MAX_PATH ) ;
	LogPrintf( "\f ================= OL^Jn ===============\n" ) ;
	LogPrintf( "    \"%s\" is loaded from \"%s\".\n", szMyPath, szExePath ) ;
}

void CloseLog( void )
{
	// IO
	LogPrintf( "\f ================= OL^I ===============\n\n" ) ;
	// t@C
	if ( pLog ) {
		fclose( pLog ) ;
		pLog = NULL ;
	}
	// Z}tH폜
	if ( hSem ) {
		CloseHandle( hSem ) ;
		hSem = NULL ;
	}
}

void LogPrintf( const char* pszFormat,... )
{
	// OĂȂ
	if ( !pLog ) return ;
	// ݊Jn
	WaitForSingleObject( hSem, INFINITE ) ;
	// ݎL^
	const char* pszForm ;
	if ( pszFormat[0] == '\f' ) {
		SYSTEMTIME st ;
		GetLocalTime( &st ) ;
		fprintf( pLog, "[%04d/%02d/%02d-%02d:%02d:%02d.%03d] ",
			st.wYear, st.wMonth, st.wDay,
			st.wHour, st.wMinute, st.wSecond, st.wMilliseconds ) ;
		pszForm = pszFormat+1 ;
	}
	else pszForm = pszFormat ;
	// Oo
	va_list	marker ;
	va_start( marker, pszFormat ) ;
	vfprintf( pLog, pszForm, marker ) ;
	va_end( marker ) ;
	// "\n"܂܂Ăfflush
	if ( strchr( pszFormat, '\n' ) ) fflush( pLog ) ;
	// ݏI
	ReleaseSemaphore( hSem, 1, NULL ) ;
}

